Index: sansview/perspectives/fitting/modelpage.py
===================================================================
--- sansview/perspectives/fitting/modelpage.py	(revision bb18ef1c74ed79eb0630f198735ad2b14e7913ab)
+++ sansview/perspectives/fitting/modelpage.py	(revision c77d8592395f6684cf45ee976c1cac9db9c00110)
@@ -454,609 +237,230 @@
         self.parent.draw_model_name = name
         
-        self.set_panel(model)
+        self.set_model_param_sizer(self.model)
         self._draw_model()
-       
-        if hasattr(model ,"model2"):
-            name= model.model2.name
-            items = self.structbox.GetItems()
-            for i in range(len(items)):
-                if items[i]==name:
-                    self.structbox.SetSelection(i)
-                    
-        if hasattr(model ,"model1"):
-            name= model.model1.name
-            items = self.modelbox.GetItems()
-            for i in range(len(items)):
-                if items[i]==name:
-                    self.modelbox.SetSelection(i)
-        else:
-            # Select the model from the combo box
-            items = self.modelbox.GetItems()
-            for i in range(len(items)):
-                if items[i]==name:
-                    self.modelbox.SetSelection(i)
-            self.structbox.SetValue("No Structure")
-                    
+        ## keep the sizer view consistent with the model menu selecting
+        ##
+        self.structurebox.Hide()
+        self.text2.Hide()
+        self.multip_cb.SetValue(False)
+        
+        if hasattr( model,"model1"):
+            self._set_model_sizer_selection( model )
+        
         self.model_view.SetFocus()
-                
-    def _on_select_Disp(self,event):
-        """
-             allow selecting different dispersion
-             self.disp_list should change type later .now only gaussian
-        """
-        type =event.GetString()
-        self.set_panel_dispers( self.disp_list,type )
-                
-    def _on_select_model(self,event):
-        """
-            react when a model is selected from page's combo box
-            post an event to its owner to draw an appropriate theory
-        """
-        self.disable_disp.SetValue(True)
-        self.sizer8.Clear(True)
-        self.sizer7.Clear(True)       
-        self.vbox.Layout()
-        self.SetScrollbars(20,20,55,40)
-        self.Layout()
-        self.parent.GetSizer().Layout()
-        form_factor =self.modelbox.GetClientData(self.modelbox.GetCurrentSelection())
-        struct_factor =self.structbox.GetClientData(self.structbox.GetCurrentSelection())
-       
-        if form_factor!="separator":
-            if struct_factor != None and struct_factor.__name__ != "NoStructure":
-                from sans.models.MultiplicationModel import MultiplicationModel
-                self.model= MultiplicationModel(form_factor(),struct_factor())
-            else:
-                 self.model= form_factor()
-        else:
-            self.model=None 
-            msg= " Select non - model value:%s !Please select another model"%name 
-            wx.PostEvent(self.parent.parent, StatusEvent(status= msg))
-               
-        self.set_model_description(self.model)
-        self.set_panel(self.model)
-        self.name= self.model.name
-        self.model_view.SetFocus()
-        self.parent.model_page.name= self.name
-        self.parent.draw_model_name= self.name
-        self._draw_model()
+                         
+    
+    def set_model_description(self,description,sizer):
+        """
+            fill a sizer with description
+            @param description: of type string
+            @param sizer: wx.BoxSizer()
+        """
+    
+        sizer.Clear(True)
+        box_description= wx.StaticBox(self, -1, 'Model Description')
+        boxsizer1 = wx.StaticBoxSizer(box_description, wx.VERTICAL)
             
-    def get_model_box(self): 
-        """ return reference to combox box self.model"""
-        return self.modelbox
-
-    
-    def get_param_list(self):
-        """
-            @return self.param_toFit: list containing  references to TextCtrl
-            checked.Theses TextCtrl will allow reference to parameters to fit.
-            @raise: if return an empty list of parameter fit will nnote work 
-            properly so raise ValueError,"missing parameter to fit"
-        """
-        if self.param_toFit !=[]:
-            return self.param_toFit
-        else:
-            raise ValueError,"missing parameter to fit"
-        
-        
-    def set_panel(self,model):
+        sizer_selection=wx.BoxSizer(wx.HORIZONTAL)
+      
+        self.description_show = wx.RadioButton(self, -1, 'Show', style=wx.RB_GROUP)
+        self.description_hide = wx.RadioButton(self, -1, 'Hide')
+        
+        if description=="":
+            self.description_hide.SetValue(True)
+            description=" Description unavailable. Click for details"
+            
+        self.description = wx.StaticText( self,-1,str(description) )
+        
+        self.Bind( wx.EVT_RADIOBUTTON, self._on_display_description,
+                   id=self.description_hide.GetId() )
+        
+        self.Bind( wx.EVT_RADIOBUTTON, self._on_display_description,
+                   id=self.description_show.GetId() )
+        
+        self.model_description = wx.Button(self, -1, "More Details")
+        self.model_description.SetToolTipString("See more description in help menu.")
+        
+        self.page_info.save_radiobox_state( self.description_hide )
+        self.page_info.save_radiobox_state( self.description_show )
+        
+        sizer_selection.Add( self.description_show )
+        sizer_selection.Add( (20,20)) 
+        sizer_selection.Add( self.description_hide )
+        sizer_selection.Add( (20,20)) 
+        sizer_selection.Add( self.model_description )
+        
+         
+        self.sizer_description=wx.BoxSizer(wx.HORIZONTAL)
+        self.sizer_description.Add( self.description, 1, wx.EXPAND | wx.ALL, 10 )
+       
+        boxsizer1.Add( sizer_selection) 
+        boxsizer1.Add( (20,20)) 
+        boxsizer1.Add( self.sizer_description) 
+    
+
+        sizer.Add(boxsizer1,0, wx.EXPAND | wx.ALL, 10)
+        sizer.Layout()
+   
+   
+   
+    def set_range(self, qmin, qmax, npts):
+        """
+            Set the range for the plotted models
+            @param qmin: minimum Q
+            @param qmax: maximum Q
+            @param npts: number of Q bins
+        """
+        # Set the data members
+        self.qmin_x = qmin_x
+        self.qmax_x = qmax_x
+        self.num_points = npts
+        
+        # Set the controls
+        self.qmin.SetValue(format_number(self.qmin_x))
+        self.qmax.SetValue(format_number(self.qmax_x))
+        self.npts.SetValue(format_number(self.num_points))
+        
+        
+    def set_model_param_sizer(self, model):
         """
             Build the panel from the model content
             @param model: the model selected in combo box for fitting purpose
         """
-       
-        self.sizer5.Clear(True)
+        self.sizer3.Clear(True)
         self.parameters = []
         self.param_toFit=[]
         self.fixed_param=[]
-        if model !=None:
-            self.model = model
+        
+        if model ==None:
+            ##no model avaiable to draw sizer 
+            return
+        box_description= wx.StaticBox(self, -1,str("Model Parameters"))
+        boxsizer1 = wx.StaticBoxSizer(box_description, wx.VERTICAL)
+        sizer = wx.GridBagSizer(5,5)
+        
+        self.model = model
+        self.set_model_description(self.model.description,self.sizer2)
+       
+        keys = self.model.getParamList()
+        #list of dispersion paramaters
+        self.disp_list=self.model.getDispParamList()
+       
+        keys.sort()
+    
+        iy = 1
+        ix = 0
+        self.text1_2 = wx.StaticText(self, -1, 'Names')
+        sizer.Add(self.text1_2,(iy, ix),(1,1),\
+                             wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
+        ix +=1
+        self.text2_2 = wx.StaticText(self, -1, 'Values')
+        sizer.Add(self.text2_2,(iy, ix),(1,1),\
+                            wx.EXPAND|wx.ADJUST_MINSIZE, 0) 
+        ix +=1
+        self.text2_4 = wx.StaticText(self, -1, 'Units')
+        sizer.Add(self.text2_4,(iy, ix),(1,1),\
+                            wx.EXPAND|wx.ADJUST_MINSIZE, 0) 
+        self.text2_4.Hide()
+        
+
+        for item in keys:
+            if not item in self.disp_list:
+                iy += 1
+                ix = 0
+    
+                name = wx.StaticText(self, -1,item)
+                sizer.Add( name,( iy, ix),(1,1),
+                             wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
+               
+                ix += 1
+                value= self.model.getParam(item)
+                ctl1 = wx.TextCtrl(self, -1, size=(_BOX_WIDTH,20),
+                                    style=wx.TE_PROCESS_ENTER)
+                
+                ctl1.SetValue(str (format_number(value)))
+                ctl1.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
+                ctl1.Bind(wx.EVT_TEXT_ENTER,self._onparamEnter)
+                sizer.Add(ctl1, (iy,ix),(1,1), wx.EXPAND)
+        
+                ix +=1
+                # Units
+                try:
+                    units = wx.StaticText(self, -1, self.model.details[item][0], style=wx.ALIGN_LEFT)
+                except:
+                    units = wx.StaticText(self, -1, "", style=wx.ALIGN_LEFT)
+                sizer.Add(units, (iy,ix),(1,1),  wx.EXPAND|wx.ADJUST_MINSIZE, 0)
+                
+                ##[cb state, name, value, "+/-", error of fit, min, max , units]
+                self.parameters.append([None,item, ctl1,
+                                        None,None, None, None,None])
+                
+        iy+=1
+        sizer.Add((20,20),(iy,ix),(1,1), wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
+        
+        #Display units text on panel
+        for item in keys:   
+            if self.model.details[item][0]!='':
+                self.text2_4.Show()
+                break
+            else:
+                self.text2_4.Hide()
+        
+        boxsizer1.Add(sizer)
+        
+        self.sizer3.Add(boxsizer1,0, wx.EXPAND | wx.ALL, 10)
+        self.sizer3.Layout()
+        self.SetScrollbars(20,20,200,100)
+        
+    
             
-            self.set_model_description( self.model) 
-            
-            keys = self.model.getParamList()
-            #list of dispersion paramaters
-            self.disp_list=self.model.getDispParamList()
-           
-            keys.sort()
-            ik=0
-            im=1
-            
-            iy = 1
-            ix = 0
-            self.cb1 = wx.CheckBox(self, -1,"Select all", (10, 10))
-            if self.data!=None:
-                wx.EVT_CHECKBOX(self, self.cb1.GetId(), self.select_all_param)
-                self.cb1.SetValue(False)
-            else:
-                self.cb1.Disable()
-                self.cb1.Hide()
-           
-            self.sizer5.Add(self.cb1,(iy, ix),(1,1),\
-                              wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
-            ix +=1
-            self.text2_2 = wx.StaticText(self, -1, 'Values')
-            self.sizer5.Add(self.text2_2,(iy, ix),(1,1),\
-                                wx.EXPAND|wx.ADJUST_MINSIZE, 0) 
-            ix +=2
-            self.text2_3 = wx.StaticText(self, -1, 'Errors')
-            self.sizer5.Add(self.text2_3,(iy, ix),(1,1),\
-                                wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-            self.text2_3.Hide() 
-            
-           
-            ix +=1
-            self.text2_4 = wx.StaticText(self, -1, 'Units')
-            self.sizer5.Add(self.text2_4,(iy, ix),(1,1),\
-                                wx.EXPAND|wx.ADJUST_MINSIZE, 0) 
-            self.text2_4.Hide()
-            disp_list=self.model.getDispParamList()
-            for item in keys:
-                if not item in disp_list:
-                    iy += 1
-                    ix = 0
-        
-                    cb = wx.CheckBox(self, -1, item, (10, 10))
-                    if self.data!=None:
-                        cb.SetValue(False)
-                        wx.EVT_CHECKBOX(self, cb.GetId(), self.select_param)
-                    else:
-                        cb.Disable()
-                    self.sizer5.Add( cb,( iy, ix),(1,1),  wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
-                   
-                    ix += 1
-                    value= self.model.getParam(item)
-                    ctl1 = wx.TextCtrl(self, -1, size=(_BOX_WIDTH,20), style=wx.TE_PROCESS_ENTER)
-                    ctl1.SetValue(str (format_number(value)))
-                    ctl1.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
-                    ctl1.Bind(wx.EVT_TEXT_ENTER,self._onparamEnter)
-                    self.sizer5.Add(ctl1, (iy,ix),(1,1), wx.EXPAND)
-                    
-                    ix += 1
-                    text2=wx.StaticText(self, -1, '+/-')
-                    self.sizer5.Add(text2,(iy, ix),(1,1),\
-                                    wx.EXPAND|wx.ADJUST_MINSIZE, 0) 
-                    text2.Hide()  
-                    ix += 1
-                    ctl2 = wx.TextCtrl(self, -1, size=(_BOX_WIDTH,20), style=wx.TE_PROCESS_ENTER)
-                    self.sizer5.Add(ctl2, (iy,ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-                    ctl2.Hide()
-                   
-                    ix +=1
-                    # Units
-                    try:
-                        units = wx.StaticText(self, -1, self.model.details[item][0], style=wx.ALIGN_LEFT)
-                    except:
-                        units = wx.StaticText(self, -1, "", style=wx.ALIGN_LEFT)
-                    self.sizer5.Add(units, (iy,ix),(1,1),  wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-               
-                    self.parameters.append([cb,ctl1,text2,ctl2])
-                    
-            iy+=1
-            self.sizer5.Add((20,20),(iy,ix),(1,1), wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
-            
-            #Display units text on panel
-            for item in keys:   
-                if self.model.details[item][0]!='':
-                    self.text2_4.Show()
-                    break
-                else:
-                    self.text2_4.Hide()
-            
-        self.vbox.Layout()
-        self.SetScrollbars(20,20,55,40)
-        self.Layout()
-        self.parent.GetSizer().Layout()
-        
-        
-        
-    def _selectDlg(self):
-        import os
-        dlg = wx.FileDialog(self, "Choose a weight file", os.getcwd(), "", "*.*", wx.OPEN)
-        path = None
-        if dlg.ShowModal() == wx.ID_OK:
-            path = dlg.GetPath()
-        dlg.Destroy()
-        return path
-    def read_file(self, path):
-        try:
-            if path==None:
-                wx.PostEvent(self.parent.parent, StatusEvent(status=\
-                            " Selected Distribution was not loaded: %s"%path))
-                return None, None
-            input_f = open(path, 'r')
-            buff = input_f.read()
-            lines = buff.split('\n')
-            
-            angles = []
-            weights=[]
-            for line in lines:
-                toks = line.split()
-                if len(toks)==2:
-                    try:
-                        angle = float(toks[0])
-                        weight = float(toks[1])
-                    except:
-                        # Skip non-data lines
-                        pass
-                    angles.append(angle)
-                    weights.append(weight)
-            return numpy.array(angles), numpy.array(weights)
-        except:
-            raise 
-        
-          
-    def select_disp_angle(self, event): 
-        """
-            Event for when a user select a parameter to average over.
-            @param event: check box event
-        """
-        
-        
-        # Go through the list of dispersion check boxes to identify which one has changed 
-        for p in self.disp_cb_dict:
-            # Catch which one of the box was just checked or unchecked.
-            if event.GetEventObject() == self.disp_cb_dict[p]:              
-
+        
+class HelpWindow(wx.Frame):
+    def __init__(self, parent, id, title):
+        wx.Frame.__init__(self, parent, id, title, size=(570, 400))
+       
+        from sans.models.CylinderModel import CylinderModel
+        model = CylinderModel()
+        #from sans.models.LineModel import LineModel
+        #model = LineModel()
+        from pageInfo import PageInfo
+        myinfo = PageInfo(self,model)
+        from models import ModelList
+        mylist= ModelList()
+        
+        from sans.models.SphereModel import SphereModel
+        from sans.models.SquareWellStructure import SquareWellStructure
+        from sans.models.DebyeModel import DebyeModel
+        from sans.models.LineModel import LineModel
+        name= "shapes"
+        list1= [SphereModel]
+        mylist.set_list( name, list1)
+        
+        name= "Shape-independent"
+        list1= [DebyeModel]
+        mylist.set_list( name, list1)
+        
+        name= "Structure Factors"
+        list1= [SquareWellStructure]
+        mylist.set_list( name, list1)
+        
+        name= "Added models"
+        list1= [LineModel]
+        mylist.set_list( name, list1)
+        
+        myinfo.model_list_box = mylist.get_list()
+        
+        self.page = ModelPage(self, myinfo) 
+        
+        
+        
+        self.Centre()
+        self.Show(True)
+
+
+   
+if __name__=="__main__":
+    app = wx.App()
+    HelpWindow(None, -1, 'HelpWindow')
+    app.MainLoop()
                 
-                if self.disp_cb_dict[p].GetValue() == True:
-                    # The user wants this parameter to be averaged. 
-                    # Pop up the file selection dialog.
-                    path = self._selectDlg()
-                    
-                    # If nothing was selected, just return
-                    if path is None:
-                        self.disp_cb_dict[p].SetValue(False)
-                        return
-                    
-                    try:
-                        values,weights = self.read_file(path)
-                    except:
-                        wx.PostEvent(self.parent.parent, StatusEvent(status=\
-                            "Could not read input file"))
-                        return
-                    
-                    # If any of the two arrays is empty, notify the user that we won't
-                    # proceed 
-                    if values is None or weights is None:
-                        wx.PostEvent(self.parent.parent, StatusEvent(status=\
-                            "The loaded %s distrubtion is corrupted or empty" % p))
-                        return
-                        
-                    # Tell the user that we are about to apply the distribution
-                    wx.PostEvent(self.parent.parent, StatusEvent(status=\
-                            "Applying loaded %s distribution: %s" % (p, path)))  
-                    
-                    # Create the dispersion objects
-                    disp_model = ArrayDispersion()
-                    disp_model.set_weights(values, weights)
-                    # Store the object to make it persist outside the scope of this method
-                    #TODO: refactor model to clean this up?
-                    self._disp_obj_dict[p] = disp_model
-                    
-                    # Set the new model as the dispersion object for the selected parameter
-                    self.model.set_dispersion(p, disp_model)
-                    
-                    
-                    # Redraw the model
-                    self._draw_model()
-                         
-                else:
-                    # The parameter was un-selected. Go back to Gaussian model (with 0 pts)
-                    disp_model = GaussianDispersion()
-                    # Store the object to make it persist outside the scope of this method
-                    #TODO: refactor model to clean this up?
-                    self._disp_obj_dict[p] = disp_model
-                    
-                    # Set the new model as the dispersion object for the selected parameter
-                    self.model.set_dispersion(p, disp_model)
-                    
-                    # Redraw the model
-                    self._draw_model()
-        return
-
-                      
-                      
-                      
-    def set_panel_dispers(self, disp_list, type="GaussianModel" ):
-        """
-        """
-        
-        self.fittable_param=[]
-        self.fixed_param=[]
-        
-        ix=0
-        iy=1
-                ### this will become a separate method
-        if type== "Select customized Model":
-            ix=0
-            iy=1
-            self.sizer8.Clear(True)        
-            disp1 = wx.StaticText(self, -1, 'Array Dispersion')
-            self.sizer8.Add(disp1,( iy, ix),(1,1),  wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
-            
-            # Look for model parameters to which we can apply an ArrayDispersion model
-            # Add a check box for each parameter.
-            self.disp_cb_dict = {}
-            for p in self.model.dispersion.keys():
-                ix+=1 
-                self.disp_cb_dict[p] = wx.CheckBox(self, -1, p, (10, 10))
-                
-                wx.EVT_CHECKBOX(self, self.disp_cb_dict[p].GetId(), self.select_disp_angle)
-                self.sizer8.Add(self.disp_cb_dict[p], (iy, ix), (1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-            
-            ix =0
-            iy +=1 
-            self.sizer8.Add((20,20),(iy,ix),(1,1), wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)        
-            self.vbox.Layout()
-            self.SetScrollbars(20,20,55,40)
-            self.Layout()
-            self.parent.GetSizer().Layout()  
-           
-        if type== "GaussianModel" :
-
-            self.sizer8.Clear(True)
-            disp = wx.StaticText(self, -1, 'Dispersion')
-            self.sizer8.Add(disp,( iy, ix),(1,1),  wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
-            ix += 1 
-            values = wx.StaticText(self, -1, 'Values')
-            self.sizer8.Add(values,( iy, ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-            ix +=2
-            self.text2_3 = wx.StaticText(self, -1, 'Errors')
-            self.sizer8.Add(self.text2_3,(iy, ix),(1,1),\
-                            wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-            self.text2_3.Hide() 
-           
-            ix += 1 
-            npts = wx.StaticText(self, -1, 'Npts')
-            self.sizer8.Add(npts,( iy, ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-            ix += 1 
-            nsigmas = wx.StaticText(self, -1, 'Nsigmas')
-            self.sizer8.Add(nsigmas,( iy, ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-            
-            disp_list.sort()
-            #print disp_list,self.model.dispersion
-            for item in self.model.dispersion.keys():
-                name1=item+".width"
-                name2=item+".npts"
-                name3=item+".nsigmas"
-                iy += 1
-                for p in self.model.dispersion[item].keys():
-                    #print "name 1 2 3", name1, name2, name3
-                    if p=="width":
-                        ix = 0
-                        cb = wx.CheckBox(self, -1, name1, (10, 10))
-                        if self.data !=None:
-                            cb.SetValue(False)
-                            wx.EVT_CHECKBOX(self, cb.GetId(), self.select_param)
-                        else:
-                            cb.Disable()
-                        self.sizer8.Add( cb,( iy, ix),(1,1),  wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
-                        ix = 1
-                        value= self.model.getParam(name1)
-                        ctl1 = wx.TextCtrl(self, -1, size=(_BOX_WIDTH,20), style=wx.TE_PROCESS_ENTER)
-                        ctl1.SetValue(str (format_number(value)))
-                        ctl1.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
-                        ctl1.Bind(wx.EVT_TEXT_ENTER,self._onparamEnter)
-                        self.sizer8.Add(ctl1, (iy,ix),(1,1), wx.EXPAND)
-                        
-                        ix = 2
-                        text2=wx.StaticText(self, -1, '+/-')
-                        self.sizer8.Add(text2,(iy, ix),(1,1),\
-                                        wx.EXPAND|wx.ADJUST_MINSIZE, 0) 
-                        text2.Hide()  
-                        ix = 3
-                        ctl2 = wx.TextCtrl(self, -1, size=(_BOX_WIDTH,20), style=wx.TE_PROCESS_ENTER)
-                        self.sizer8.Add(ctl2, (iy,ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-                        ctl2.Hide()
-                        self.fittable_param.append([cb,ctl1,text2,ctl2])
-                       
-                        
-                    elif p=="npts":
-                            ix =4 
-                            value= self.model.getParam(name2)
-                            Tctl = wx.TextCtrl(self, -1, size=(_BOX_WIDTH/2,20), style=wx.TE_PROCESS_ENTER)
-                            Tctl.SetValue(str (format_number(value)))
-                            Tctl.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
-                            Tctl.Bind(wx.EVT_TEXT_ENTER,self._onparamEnter)
-                            self.sizer8.Add(Tctl, (iy,ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-                            self.fixed_param.append([name2, Tctl])
-                    elif p=="nsigmas":
-                            ix =5 
-                            value= self.model.getParam(name3)
-                            Tctl = wx.TextCtrl(self, -1, size=(_BOX_WIDTH/2,20), style=wx.TE_PROCESS_ENTER)
-                            Tctl.SetValue(str (format_number(value)))
-                            Tctl.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
-                            Tctl.Bind(wx.EVT_TEXT_ENTER,self._onparamEnter)
-                            self.sizer8.Add(Tctl, (iy,ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-                            self.fixed_param.append([name3, Tctl])
-                wx.PostEvent(self.parent.parent, StatusEvent(status=\
-                            " Selected Distribution: Gaussian"))   
-            ix =0
-            iy +=1 
-            self.sizer8.Add((20,20),(iy,ix),(1,1), wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)        
-            self.vbox.Layout()
-            self.SetScrollbars(20,20,55,40)
-            self.Layout()
-            self.parent.GetSizer().Layout()  
-          
-    def checkFitValues(self,val_min, val_max):
-        """
-            Check the validity of input values
-        """
-        flag = True
-        min_value = val_min.GetValue()
-        max_value = val_max.GetValue()
-        # Check for possible values entered
-        if min_value.lstrip().rstrip() =="-inf":
-            min_value= -numpy.inf
-        if max_value.lstrip().rstrip() =="+inf":
-            max_value= numpy.inf
-        if  min_value==-numpy.inf and max_value== numpy.inf:
-            val_min.SetBackgroundColour(wx.WHITE)
-            val_min.Refresh()
-            val_max.SetBackgroundColour(wx.WHITE)
-            val_max.Refresh()
-            return flag
-        elif max_value== numpy.inf:
-            try:
-                float(min_value)
-                val_min.SetBackgroundColour(wx.WHITE)
-                val_min.Refresh()
-            except:
-                flag = False
-                val_min.SetBackgroundColour("pink")
-                val_min.Refresh()
-            return flag
-        elif min_value==-numpy.inf:
-            try:
-                float(max_value)
-                val_max.SetBackgroundColour(wx.WHITE)
-                val_max.Refresh()
-            except:
-                flag = False
-                val_max.SetBackgroundColour("pink")
-                val_max.Refresh()
-            return flag
-        else:    
-            if (float(min_value)< float(max_value)):
-                val_min.SetBackgroundColour(wx.WHITE)
-                val_min.Refresh()
-            else:
-                flag = False
-                val_min.SetBackgroundColour("pink")
-                val_min.Refresh()
-            return flag   
-           
-        
-    def _onparamEnter(self,event):
-        """ 
-            when enter value on panel redraw model according to changed
-        """
-        self.set_model_parameter()
-        
-    def set_model_parameter(self):
-        """
-        """
-        if len(self.parameters) !=0 and self.model !=None:
-            # Flag to register when a parameter has changed.
-            is_modified = False
-            for item in self.fittable_param:
-                try:
-                     name=str(item[0].GetLabelText())
-                     value= float(item[1].GetValue())
-                     # If the value of the parameter has changed,
-                     # update the model and set the is_modified flag
-                     if value != self.model.getParam(name):
-                         self.model.setParam(name,value)
-                         is_modified = True
-                         
-                except:
-                    #raise
-                    wx.PostEvent(self.parent.parent, StatusEvent(status=\
-                            "Model Drawing  Error:wrong value entered : %s"% sys.exc_value))
-                    return 
-                
-                
-            for item in self.fixed_param:
-                try:
-                     name=str(item[0])
-                     value= float(item[1].GetValue())
-                     # If the value of the parameter has changed,
-                     # update the model and set the is_modified flag
-                     if value != self.model.getParam(name):
-                         self.model.setParam(name,value)
-                         is_modified = True
-                         
-                except:
-                    raise
-                    wx.PostEvent(self.parent.parent, StatusEvent(status=\
-                            "Model Drawing  Error:wrong value entered : %s"% sys.exc_value))
-                
-            for item in self.parameters:
-                try:
-                     name=str(item[0].GetLabelText())
-                     value= float(item[1].GetValue())
-                     # If the value of the parameter has changed,
-                     # update the model and set the is_modified flag
-                     if value != self.model.getParam(name):
-                         self.model.setParam(name,value)
-                         is_modified = True
-                   
-                except:
-                    #raise 
-                    wx.PostEvent(self.parent.parent, StatusEvent(status=\
-                           "Model Drawing  Error:wrong value entered : %s"% sys.exc_value))
-                    return
-                
-                
-            # Here we should check whether the boundaries have been modified.
-            # If qmin and qmax have been modified, update qmin and qmax and 
-            # set the is_modified flag to True
-            from sans.guiframe.utils import check_value
-            if check_value( self.qmin, self.qmax):
-                if float(self.qmin.GetValue()) != self.qmin_x:
-                    self.qmin_x = float(self.qmin.GetValue())
-                    is_modified = True
-                if float(self.qmax.GetValue()) != self.qmax_x:
-                    self.qmax_x = float(self.qmax.GetValue())
-                    is_modified = True
-                self.fitrange = True
-            else:
-                self.fitrange = False
-            if float(self.npts.GetValue()) !=  self.num_points:
-                self.num_points = float(self.npts.GetValue())
-                is_modified = True
-          
-            if is_modified:
-                self._draw_model()            
-            
-    def _draw_model(self):
-        """
-            Method to draw or refresh a plotted model.
-            The method will use the data member from the model page
-            to build a call to the fitting perspective manager.
-            
-            [Note to coder: This way future changes will be done in only one place.] 
-        """
-        if self.model !=None:
-            self.manager.draw_model(self.model, self.model.name, data=self.data,
-                                    qmin=self.qmin_x, qmax=self.qmax_x,
-                                    qstep= self.num_points,
-                                    enable2D=self.enable2D)
-       
-    def select_param(self,event):
-        """
-        
-        """
-        pass
-    def select_all_param(self,event): 
-        """
-        
-        """
-        pass
-    def select_all_param_helper(self):
-        """
-             Allows selecting or delecting button
-        """
-        self.param_toFit=[]
-        if  self.parameters !=[]:
-            if  self.cb1.GetValue()==True:
-                for item in self.parameters:
-                    item[0].SetValue(True)
-                    list= [item[0],item[1],item[2],item[3]]
-                    self.param_toFit.append(list )
-                if len(self.fittable_param)>0:
-                    for item in self.fittable_param:
-                        item[0].SetValue(True)
-                        list= [item[0],item[1],item[2],item[3]]
-                        self.param_toFit.append(list )
-            else:
-                for item in self.parameters:
-                    item[0].SetValue(False)
-                for item in self.fittable_param:
-                    item[0].SetValue(False)
-                self.param_toFit=[]
-               
-                
-       
